package ch.zhaw.projekt2.turnierverwaltung.main;

import ch.zhaw.projekt2.turnierverwaltung.Factory;
import ch.zhaw.projekt2.turnierverwaltung.FactoryDecorator;
import ch.zhaw.projekt2.turnierverwaltung.FileIO;
import ch.zhaw.projekt2.turnierverwaltung.TournamentDecorator;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;


public class MainWindow extends Application {
    private FileIO fileIO = new FileIO(System.getProperty("user.dir") + System.getProperty("file.separator") + "tournierverwaltung_angrynerds");
    private FactoryDecorator factoryDecorator;
    private TournamentDecorator tournamentDecorator = new TournamentDecorator(fileIO);
    private Factory factory = new Factory(fileIO, tournamentDecorator); //TODO make it private!

    @Override
    public void start(Stage primaryStage) throws Exception {

        BorderPane pane = factory.loadMainWindow();
        factoryDecorator = new FactoryDecorator(fileIO, factory, pane);
        tournamentDecorator.setFactoryDecorator(factoryDecorator);
        factoryDecorator.openTournamentList();


        Scene scene = new Scene(pane);
        primaryStage.setScene(scene);
        primaryStage.setMaximized(true);
        primaryStage.setResizable(true);
        primaryStage.setFullScreen(false);
        primaryStage.show();
    }


}
