package ch.zhaw.projekt2.turnierverwaltung.main.participantAddFormular;

import ch.zhaw.projekt2.turnierverwaltung.FXController;
import ch.zhaw.projekt2.turnierverwaltung.Participant;
import ch.zhaw.projekt2.turnierverwaltung.Player;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.VBox;

public class ParticipantFormularController extends FXController {

    @FXML
    private Button addBtn;

    @FXML
    private Label birthDateLabel;

    @FXML
    private TextField birthDateTextField;

    @FXML
    private VBox changeBtn;

    @FXML
    private Label firstNameLabel;

    @FXML
    private TextField firstNameTextField;

    @FXML
    private GridPane grid;

    @FXML
    private Label newParticipantFormularTitle;

    @FXML
    private Button closeBtn;

    @FXML
    private Button deleteBtn;


    @FXML
    private Label participantListTitle;

    @FXML
    private ListView<Participant> participantListView;

    @FXML
    private Label participantNameLabel;

    @FXML
    private TextField participantNameTextField;

    @FXML
    private Label phoneNumberLabel;

    @FXML
    private TextField phoneNumberTextField;

    @FXML
    private Button saveBtn;

    @FXML
    void changedSelection(MouseEvent event){
        Player participant = (Player) participantListView.getSelectionModel().getSelectedItems().get(0);
        participantNameTextField.setText(participant.getName());
        firstNameTextField.setText(participant.getFirstName());
        phoneNumberTextField.setText(participant.getPhoneNumber());
        birthDateTextField.setText(participant.getFormatedDateOfBirth());
    }

    @FXML
    void saveParticipant(ActionEvent event) {
        getTournamentDecorator().savePlayer(firstNameTextField.getText(), participantNameTextField.getText(), phoneNumberTextField.getText(), birthDateTextField.getText());
        clearFormular();
    }

    private void clearFormular() {
        firstNameTextField.clear();
        participantNameTextField.clear();
        phoneNumberTextField.clear();
        birthDateTextField.clear();
    }

    @FXML
    void delete(ActionEvent event) {
        Participant participant = participantListView.getSelectionModel().getSelectedItems().get(0);
        getTournamentDecorator().deleteParticipant(participant);
    }

    @FXML
    void close(ActionEvent event) {
        removeListener();
        getFactoryDecorator().openScheduleView();
    }

    @Override
    public void loadContent() {
        participantListView.setItems(getTournamentDecorator().getTournament().getParticipants());
    }
}
