package ch.zhaw.projekt2.turnierverwaltung.main.placesAddFormular;

import ch.zhaw.projekt2.turnierverwaltung.FXController;
import ch.zhaw.projekt2.turnierverwaltung.Place;
import ch.zhaw.projekt2.turnierverwaltung.Player;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.VBox;

public class PlacesFormularController extends FXController {

    @FXML
    private Button addBtn;

    @FXML
    private VBox changeBtn;

    @FXML
    private GridPane grid;

    @FXML
    private Label newPlaceFormularTitle;

    @FXML
    private Button closeBtn;

    @FXML
    private Button deleteBtn;


    @FXML
    private Label placeListTitle;

    @FXML
    private ListView<Place> placeListView;

    @FXML
    private Label placeNameLabel;

    @FXML
    private TextField placeNameTextField;

    @FXML
    private Button saveBtn;

    @FXML
    void changedSelection(MouseEvent event){
        Place place = placeListView.getSelectionModel().getSelectedItems().get(0);
        placeNameTextField.setText(place.getName());
    }

    @FXML
    void savePlace(ActionEvent event) {
        getTournamentDecorator().savePlace(placeNameTextField.getText());
        clearFormular();
    }

    private void clearFormular() {
        placeNameTextField.clear();
    }

    @FXML
    void delete(ActionEvent event) {
        Place place = placeListView.getSelectionModel().getSelectedItems().get(0);
        getTournamentDecorator().deletePlace(place);
    }

    @FXML
    void close(ActionEvent event) {
        removeListener();
        getFactoryDecorator().openScheduleView();
    }

    @Override
    public void loadContent() {
        placeListView.setItems(getTournamentDecorator().getTournament().getPlaces());
    }
}
